Loading...
Searching...
No Matches
BALL::VIEW::Scene Class Reference
Visualisation » Modular Widgets

`#include <BALL/VIEW/WIDGETS/scene.h>`

Inheritance diagram for BALL::VIEW::Scene:

## Public Types

Enums
enum | WindowType { CONTROL_WINDOW = 0 , LEFT_EYE_WINDOW , RIGHT_EYE_WINDOW }
Public Types inherited from BALL::Embeddable
typedef std::vector< Embeddable * > | EmbeddableVector

## Public Member Functions

Constructors and Destructor
| Scene (QWidget *parent_widget=0, const char *name=NULL, Qt::WindowFlags w_flags=0)
virtual | ~Scene ()
virtual void | clear ()
Accessors: inspectors and mutators
virtual void | onNotify (Message *message)
virtual bool | exportScene (Renderer &er) const
String | getBondOrderString_ (Index order)
virtual void | initializeWidget (MainControl &main_control)
virtual void | fetchPreferences (INIFile &inifile)
virtual void | writePreferences (INIFile &inifile)
virtual void | checkMenu (MainControl &main_control)
Public Member Functions inherited from BALL::VIEW::ModularWidget
| ModularWidget (const char *name="<ModularWidget>")
| ModularWidget (const ModularWidget &widget)
virtual | ~ModularWidget ()
virtual void | destroy ()
QAction * | insertMenuEntry (Position parent_id, const QString &name, const QObject *receiver=0, const char *slot=0, const String &description="", QKeySequence accel=QKeySequence(), const QString &menu_hint=QString(""), UIOperationMode::OperationMode minimal_mode=UIOperationMode::MODE_ALL)
BALL_DEPRECATED void | setMenuHelp (QAction *, const String &)
virtual BALL_DEPRECATED void | registerForHelpSystem (const QObject *, const String &)
void | setIcon (QAction *action, const String &filename, bool add_to_main_toolbar=true)
bool | lockComposites ()
bool | unlockComposites ()
| Unlock the Composites.
MainControl * | getMainControl () const
virtual void | setStatusbarText (const String &text, bool important=false)
virtual void | setStatusbarText (const QString &text, bool important=false)
String | getWorkingDir ()
| Implemented for convenience.
void | setWorkingDir (const String &dir)
| Implemented for convenience.
FragmentDB & | getFragmentDB () const
void | setWorkingDirFromFilename_ (String filename)
virtual BALL_DEPRECATED void | showHelp (const String &)
virtual void | finalizeWidget (MainControl &main_control)
virtual bool | canHandle (const String &) const
virtual bool | openFile (const String &)
Public Member Functions inherited from BALL::Embeddable
| Embeddable (const String &identifier="<Embeddable>")
| Embeddable (const Embeddable &embeddable)
virtual | ~Embeddable ()
void | setIdentifier (const String &identifier)
const String & | getIdentifier () const
void | unregisterThis ()
virtual void | registerThis ()
Public Member Functions inherited from BALL::VIEW::ConnectionObject
| ConnectionObject ()
virtual | ~ConnectionObject ()
void | registerConnectionObject (ConnectionObject &object)
void | unregisterConnectionObject (ConnectionObject &object)
bool | isConnectionObjectRegistered (const ConnectionObject &object)
ConnectionObject * | getParent () const
ConnectionObject * | getRoot ()

## Friends

class | AnimationThread
class | RenderSetup

## Protected slots

QAction * | new_molecule_action_
QAction * | optimize_action_
QAction * | add_hydrogens_action_
QAction * | bondorders_action_
Atom * | current_atom_
Bond * | current_bond_
int | atomic_number_
vector< EditOperation > | undo_
EditSettings * | edit_settings_
QList< QAction * > | toolbar_actions_edit_controls_
static bool | only_highlighted_
virtual void | showViewPoint_ ()
| Show the viewpoint and the look at point in the statusline of the mainwidget.
virtual void | setViewPoint_ ()
| Set the viewpoint.
virtual void | resetCamera_ ()
| Reset the camera to standard values.
virtual void | resetRepresentationsForRenderer_ (RenderSetup &rs)
virtual void | dropEvent (QDropEvent *e)
virtual void | dragEnterEvent (QDragEnterEvent *e)
void | dummySlot ()
void | newEditOperation (EditOperation &eo)
void | handleRepresentationMessage_ (RepresentationMessage *rm)
void | handleDatasetMessage_ (DatasetMessage *dm)
void | handleSceneMessage_ (SceneMessage *sm)
void | handleCompositeMessage_ (CompositeMessage *cm)
void | handleControlSelectionMessage_ (ControlSelectionMessage *csm)
virtual void | handleRenderToBufferFinishedEvent_ (RenderToBufferFinishedEvent *evt)
void | renderText_ (QPointF const &point, QString const &text, QPaintDevice *current_dev)
void | insert_ (int x_, int y_, PDBAtom &atom_)
TVector2< float > | getScreenPosition_ (Vector3 vec)
void | initializeMembers_ ()
void | renderGrid_ ()

## Protected QT overridden virtual methods

QAction * | no_stereo_action_
QAction * | enter_stereo_action_
QAction * | active_stereo_action_
QAction * | dual_stereo_action_
QAction * | dual_stereo_different_display_action_
QAction * | record_animation_action_
QAction * | start_animation_action_
QAction * | clear_animation_action_
QAction * | cancel_animation_action_
QAction * | animation_export_POV_action_
QAction * | animation_export_VRML_action_
QAction * | animation_export_PNG_action_
QAction * | animation_repeat_action_
QAction * | switch_grid_
QMenu * | create_coordinate_system_
Vector3 | system_origin_
Vector3 | old_trackorigin_
bool | tracking_initialized_
Quaternion | old_trackrotation_
bool | update_running_
QRubberBand * | rb_
Stage * | stage_
Camera | stereo_camera_
Camera | stored_camera_
std::vector< boost::shared_ptr< RenderSetup > > | renderers_
GLRenderer * | gl_renderer_
LightSettings * | light_settings_
StageSettings * | stage_settings_
MaterialSettings * | material_settings_
std::list< Camera > | animation_points_
AnimationThread * | animation_thread_
bool | stop_animation_
bool | want_to_use_vertex_buffer_
bool | use_preview_
PreciseTime | time_
QPoint | info_point_
QByteArray | last_state_
list< float > | fps_
bool | show_fps_
Size | offscreen_factor_
Size | font_size_
QToolBar * | toolbar_view_controls_
QToolBar * | toolbar_edit_controls_
QList< QAction * > | toolbar_actions_view_controls_
QString | info_string_
GLRenderWindow * | main_display_
Position | main_renderer_
| The index of the renderer responsible for the main display.
Index | stereo_left_eye_
Index | stereo_right_eye_
QFont | default_font_
QPicture | overlay_
bool | has_overlay_
InteractionModeManager | mode_manager_
static bool | show_light_sources_
static float | animation_smoothness_
static float | downsampling_factor_
static Position | screenshot_nr_
static Position | pov_nr_
static Position | vrml_nr_
static bool | offscreen_rendering_
virtual void | init ()
virtual void | paintGL ()
virtual void | resizeEvent (QResizeEvent *event)
virtual void | customEvent (QEvent *evt)
virtual void | transformationEvent6D (TransformationEvent6D *evt)
virtual void | motionTrackingEvent (MotionTrackingEvent *evt)
virtual void | buttonPressEvent (ButtonEvent *evt)
virtual void | buttonReleaseEvent (ButtonEvent *evt)
virtual void | mouseMoveEvent (QMouseEvent *qmouse_event)
virtual void | mousePressEvent (QMouseEvent *qmouse_event)
virtual void | mouseReleaseEvent (QMouseEvent *qmouse_event)
virtual void | wheelEvent (QWheelEvent *qmouse_event)
virtual void | mouseDoubleClickEvent (QMouseEvent *e)
void | animate_ ()
void | rotateSystemClockwise_ ()
void | zoomSystem_ ()
void | selectionPressed_ ()
void | selectionPressedMoved_ ()
void | selectObjects_ ()
void | pickParent_ (QPoint p)
void | writeLights_ (INIFile &inifile) const
void | readLights_ (const INIFile &inifile)
void | createCoordinateSystem_ (bool at_origin)
void | registerRenderers_ ()
String | createFPSInfo_ (Renderer *renderer)
| Estimate current fps and convert into a string.

## Debugging and Diagnostics

virtual bool | isValid () const
virtual void | dump (std::ostream &s=std::cout, Size depth=0) const
void | setInfo (const QString &info_string)
bool | isRecording () const
void | captureCamera ()
Atom * | getCurrentAtom ()
void | setCurrentAtom (Atom *atom)
void | notify (Message *msg)
Vector2 | map3DToViewport (const Vector3 &coords)
Vector3 | mapViewportTo3D (const Vector2 &coords)
Vector3 | mapViewportTo3D (int x, int y)
void | setRubberBandGeometry (const QRect &rect)
void | setRubberBandVisible (bool show)
void | pickObjects (const QPoint &pos, list< GeometricObject * > &objects)
void | pickObjects (const QPoint &pos1, const QPoint &pos2, list< GeometricObject * > &objects)
void | merge (Composite *a1, Composite *a2)
std::list< AtomContainer * > | getContainers ()
void | enterPickingMode ()
void | exitPickingMode ()
void | drawLine (const QPointF &a, const QPointF &b, QPainter *painter=0)
void | drawLine (const Vector2 &a, const Vector2 &b, QPainter *painter=0)
Bond * | getCurrentBond ()
void | setCurrentBond (Bond *b)
void | changeBondOrder ()
void | changeBondOrder (Index delta)
void | activatedOrderItem_ (QAction *action)
void | createMolecule_ ()
void | setFormalCharge_ ()
void | deselect (bool update=true)
void | getClickedItems (const QPoint &p)
Stage * | getStage ()
const Stage * | getStage () const
StageSettings * | getStageSettings ()
const StageSettings * | getStageSettings () const
MaterialSettings * | getMaterialSettings ()
const MaterialSettings * | getMaterialSettings () const
void | setCamera (const Camera &camera)
std::list< Camera > & | getAnimationPoints ()
float | getDownsamplingFactor () const
void | setDownsamplingFactor (float ds_factor)
void | setDefaultLighting (bool update_GL=true)
GLRenderer & | getGLRenderer ()
void | setGLRenderer (GLRenderer &renderer)
bool | inMoveMode () const
bool | exportPNG (const String &filename)
virtual void | setWidgetVisible (bool state)
void | setOffScreenRendering (bool enabled, Size factor)
virtual void | paintEvent (QPaintEvent *e)
virtual bool | eventFilter (QObject *object, QEvent *event)
virtual void | projectionModeChanged ()
void | rotate (float degree_right, float degree_up)
void | rotateClockwise (float degree)
void | move (Vector3 v)
void | moveComposites (const std::list< Composite * > &composites, Vector3 v)
void | rotateComposites (const std::list< Composite * > &composites, float degree_right, float degree_up, float degree_clockwise=0)
bool | isAnimationRunning () const
void | setTurnPoint (const Vector3 &v)
const Vector3 & | getTurnPoint () const
void | setFullScreen (bool state)
void | setFPSEnabled (bool state)
void | showText (const String &text, Size font_size=20)
bool | isUpdateRunning () const
void | resetTracking ()
void | updateAllMaterials ()
void | updateMaterialForRepresentation (Representation *rep, const Stage::Material &new_material)
void | lightsUpdated (bool redraw=false)
void | setupEnvironmentMap (const QImage &image)
| Try to setup an environment map for all renderers that support it.
Position | prepareGridTextures (const RegularData3D &grid, const ColorMap &map)
void | updateGL ()
void | initializePreferencesTab (Preferences &preferences)
void | finalizePreferencesTab (Preferences &preferences)
virtual void | applyPreferences ()
void | showContextMenu (QPoint pos)
void | setCursor (String c)
void | setElementCursor (int number)
virtual void | addToolBarEntries (QToolBar *tb)
virtual void | keyPressEvent (QKeyEvent *e)
| Catch key events.
static void | setAnimationSmoothness (float value)
static float | getAnimationSmoothness ()
static BALL_DEPRECATED void | setMouseSensitivity (float)
static BALL_DEPRECATED float | getMouseSensitivity ()
static BALL_DEPRECATED void | setMouseWheelSensitivity (float)
static BALL_DEPRECATED float | getMouseWheelSensitivity ()
static void | setShowLightSources (bool state)
static bool | showLightSourcesEnabled ()
static bool | stereoBufferSupportTest ()
static void | setScreenShotNumber (Position pos)
static void | setPOVNumber (Position pos)
static void | setVRMLNumber (Position pos)
void | createCoordinateSystem ()
| Create an coordinate system at current position.
void | createCoordinateSystemAtOrigin ()
| Create an coordinate system at origin.
String | exportPNG ()
| Export PNG image and return the filename.
void | exportPOVRay ()
void | exportNextPOVRay ()
| Export to POVRay whithout showing file dialog.
void | printScene ()
void | showExportPNGDialog ()
| show an dialog to save an PNG file to
void | showExportVRMLDialog ()
| opens the VIEW/DIALOGS/GeometryExportDialog for vrml and stl export
void | setPreview (bool state)
| Enable or disable model previews e.g. while rotating.
bool | usePreview () const
| Returns the state of the preview mode.
bool | useVertexBuffers () const
virtual void | switchShowWidget ()
void | switchRenderer (RenderSetup::RendererType new_type)
void | addGlWindow ()
void | exitStereo ()
void | enterStereo ()
void | enterActiveStereo ()
void | enterDualStereo ()
void | enterDualStereoDifferentDisplays ()
void | clearRecordedAnimation ()
void | startAnimation ()
void | stopAnimation ()
void | switchToLastMode ()
void | switchShowGrid ()
void | showInfos ()
| Popup informations for object under mouse cursor.
void | setupViewVolume ()
void | storeViewPoint ()
void | restoreViewPoint ()
void | startContinuousLoop ()
void | stopContinuousLoop ()
void | toggleContinuousLoop ()
void | applyStereoDefaults ()
void | createNewMolecule ()
void | saturateWithHydrogens ()
void | optimizeStructure ()
void | computeBondOrders ()
void | setEditElementType (int element_number)
int | getEditElementType ()
InteractionModeManager & | getInteractionModeManager ()
| Returns a reference to the Scene's interaction mode manager.

## Additional Inherited Members

static void | registerWidget (ModularWidget *mwidget)
void | notify_ (Message *message)
void | notify_ (Message &message)
void | onNotify_ (Message *message)
static void | registerInstance_ (const std::type_info &type, const Embeddable *instance)
static void | unregisterInstance_ (const Embeddable *instance)
static Size | countInstances_ (const std::type_info &type)
static Embeddable * | getInstance_ (const std::type_info &type, Position index)
static Embeddable * | getInstance_ (const std::type_info &type, const String &identifier)
QAction * | window_menu_entry_
bool | show_window_enty_
bool | default_visible_
QList< QAction * > | main_toolbar_actions_

## Detailed Description

Scene is the main visualization widget that shows the graphical Representation 's. To do this, the class Scene must be a child of the MainControl. Because the MainControl is also the main application object a Scene must be created with the pointer to the MainControl as parent widget.
Scene is capable of stereo 3D view with shutter glasses and CRT monitors. This only works, if the OpenGL-driver supports this. NVIDIA cards need a Quad buffer, like they are used in the "Quad" cards. For other NVIDIA cards, you can try the tool "Rivatuner", which tries to enable this feature for cards, which natively dont support this. To enter and leave the stereo mode, press ALT-Y. If your OpenGL doesnt support the stereo view, you will see an error message in the message bar at the bottom of the main window.
The Scene has tree different mouse modi:

- Picking Mode: To select Composite 's, e.g. Molecules
- Rotate Mode: Transform your view point in the threedimensional room, e.g. rotate or zoom
- Eye Distance: Change the eye distance for stereo view

To change between the first two modi, there is a menu entry with checkboxes in the main menu bar of the application.
In Picking mode, left mouse button selects composites and right mouse button deselects. There are two ways to (de-)select: Either click on single items, or draw a selection rectangle by keeping the mouse button pressed and moving the mouse. Users with only one mouse button can use the SHIFT button, while pressing the mouse button to deselect.
In Rotate mode, left mouse button rotates, mid mouse button zooms in and out and right button moves the view. Users with only one mouse button can use the SHIFT / CONTROL button, while pressing the mouse button.
The eye distance change mode is only available in the stereo view mode. Here a user can press the ALT-button and move the mouse left or right to adjust the eye distance to their desired value.
Its possible to add new modi, to do so, derive a new class from Scene and overload the mouse*Event methods.
Furthermore, users can create modified versions of the GLRenderer and pass them to the Scene with the method setGLRenderer.

Definition at line 138 of file scene.h.

## Member Enumeration Documentation

## WindowType

enum BALL::VIEW::Scene::WindowType

Scene may hold several windows for different renering modes. If you need to retrieve a particular window, use this enum together with Scene::getWindow() to get a reference to it.

Enumerator
CONTROL_WINDOW | Main window that is always being displayed directly in the QT main interface.
LEFT_EYE_WINDOW | Window into which left eye should be rendered. Indicates same window as CONTROL_WINDOW if no stereo is running.
RIGHT_EYE_WINDOW | Window into which right eye should be renderer. Indicates same window as CONTROL_WINDOW if no stereo is running.

Definition at line 164 of file scene.h.

## Constructor & Destructor Documentation

## Scene()

BALL::VIEW::Scene::Scene | ( | QWidget * | parent_widget = 0,
|  | const char * | name = NULL,
|  | Qt::WindowFlags | w_flags = 0 )

Default Constructor. Initialize the width and height of this scene to 600 and sets the camera position.

  Calls registerWidget.

Parameters

  parent_widget | the parent widget of this scene
  name | the name of this scene
  w_flags | the flags the scene widget should have (See documentation of QT-library for information concerning widget flags)

## ~Scene()

virtual BALL::VIEW::Scene::~Scene | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## activatedOrderItem_()

void BALL::VIEW::Scene::activatedOrderItem_ | ( | QAction * | action | ) |

## addGlWindow

void BALL::VIEW::Scene::addGlWindow | ( |  | ) |

slot

## addToolBarEntries()

virtual void BALL::VIEW::Scene::addToolBarEntries | ( | QToolBar * | main_tb | ) |

virtual

Add the widgets actions to the (main) toolbar. This method is needed to enable ordering the entries. It is called in Mainframe.

Reimplemented from BALL::VIEW::ModularWidget.

## animate_()

void BALL::VIEW::Scene::animate_ | ( |  | ) |

protected

## applyPreferences()

virtual void BALL::VIEW::Scene::applyPreferences | ( |  | ) |

virtual

Apply the preferences of the specific tab. In this method the widget can extract any changed values from its preferences tab (if required). This method is called automatically by the applyPreferencesTab from the MainControl object if the apply button in the Preferences dialog is pressed.

Parameters

  preferences | the Preferences dialog of the MainControl

See also
  initializePreferencesTab
  finalizePreferencesTab
  applyPreferencesTab

Reimplemented from BALL::VIEW::ModularWidget.

## applyStereoDefaults

void BALL::VIEW::Scene::applyStereoDefaults | ( |  | ) |

slot

## buttonPressEvent()

virtual void BALL::VIEW::Scene::buttonPressEvent | ( | ButtonEvent * | evt | ) |

protected virtual

Function that interpretes the button press events sent to customEvent()

## buttonReleaseEvent()

virtual void BALL::VIEW::Scene::buttonReleaseEvent | ( | ButtonEvent * | evt | ) |

protected virtual

Function that interpretes the button release events sent to customEvent()

## captureCamera()

void BALL::VIEW::Scene::captureCamera | ( |  | ) |

## changeBondOrder() [1/2]

void BALL::VIEW::Scene::changeBondOrder | ( |  | ) |

## changeBondOrder() [2/2]

void BALL::VIEW::Scene::changeBondOrder | ( | Index | delta | ) |

## checkMenu()

virtual void BALL::VIEW::Scene::checkMenu | ( | MainControl & | main_control | ) |

virtual

Menu checking method. This method is called by MainControl::checkMenus before a popup menu is shown. The menus rotate mode and picking mode each will be checked if this scene is in the corresponding mode.

Parameters

  main_control | the MainControl object whose menus should be checked

See also
  initializeWidget
  finalizeWidget
  checkMenus
  show

Reimplemented from BALL::VIEW::ModularWidget.

## clear()

virtual void BALL::VIEW::Scene::clear | ( |  | ) |

virtual

Explicit default initialization. Reset the default values of this scene to:

- width is set to 600
- height is set to 600
- camera position set to Vector(1,0,0)
- camera look at position set to Vector(0,0,0)

Reimplemented from BALL::VIEW::ModularWidget.

## clearRecordedAnimation

void BALL::VIEW::Scene::clearRecordedAnimation | ( |  | ) |

slot

## computeBondOrders

void BALL::VIEW::Scene::computeBondOrders | ( |  | ) |

slot

## createCoordinateSystem

void BALL::VIEW::Scene::createCoordinateSystem | ( |  | ) |

slot

Create an coordinate system at current position.

## createCoordinateSystem_()

void BALL::VIEW::Scene::createCoordinateSystem_ | ( | bool | at_origin | ) |

protected

## createCoordinateSystemAtOrigin

void BALL::VIEW::Scene::createCoordinateSystemAtOrigin | ( |  | ) |

slot

Create an coordinate system at origin.

## createFPSInfo_()

String BALL::VIEW::Scene::createFPSInfo_ | ( | Renderer * | renderer | ) |

protected

Estimate current fps and convert into a string.

## createMolecule_()

void BALL::VIEW::Scene::createMolecule_ | ( |  | ) |

## createNewMolecule

void BALL::VIEW::Scene::createNewMolecule | ( |  | ) |

slot

## customEvent()

virtual void BALL::VIEW::Scene::customEvent | ( | QEvent * | evt | ) |

protected virtual

This function handles custom events that for example are sent by the input device drivers

Parameters

  evt | A pointer to the event that shell be processed

## deselect()

void BALL::VIEW::Scene::deselect | ( | bool | update = true | ) |

## dragEnterEvent

virtual void BALL::VIEW::Scene::dragEnterEvent | ( | QDragEnterEvent * | e | ) |

protected virtual slot

## drawLine() [1/2]

void BALL::VIEW::Scene::drawLine | ( | const QPointF & | a,
|  | const QPointF & | b,
|  | QPainter * | painter = 0 )

## drawLine() [2/2]

void BALL::VIEW::Scene::drawLine | ( | const Vector2 & | a,
|  | const Vector2 & | b,
|  | QPainter * | painter = 0 )

## dropEvent

virtual void BALL::VIEW::Scene::dropEvent | ( | QDropEvent * | e | ) |

protected virtual slot

## dummySlot

void BALL::VIEW::Scene::dummySlot | ( |  | ) |

inline protected slot

Definition at line 673 of file scene.h.

## dump()

virtual void BALL::VIEW::Scene::dump | ( | std::ostream & | s = std::cout,
|  | Size | depth = 0 ) const

virtual

Internal value dump. Dump the current internal state of this scene to the output ostream s with dumping depth depth.

Parameters

  s | output stream where to output the internal state of this scene
  depth | the dumping depth

Reimplemented from BALL::VIEW::ModularWidget.

## enterActiveStereo

void BALL::VIEW::Scene::enterActiveStereo | ( |  | ) |

slot

## enterDualStereo

void BALL::VIEW::Scene::enterDualStereo | ( |  | ) |

slot

## enterDualStereoDifferentDisplays

void BALL::VIEW::Scene::enterDualStereoDifferentDisplays | ( |  | ) |

slot

## enterPickingMode()

void BALL::VIEW::Scene::enterPickingMode | ( |  | ) |

## enterStereo

void BALL::VIEW::Scene::enterStereo | ( |  | ) |

slot

## eventFilter()

virtual bool BALL::VIEW::Scene::eventFilter | ( | QObject * | object,
|  | QEvent * | event )

virtual

## exitPickingMode()

void BALL::VIEW::Scene::exitPickingMode | ( |  | ) |

## exitStereo

void BALL::VIEW::Scene::exitStereo | ( |  | ) |

slot

## exportNextPOVRay

void BALL::VIEW::Scene::exportNextPOVRay | ( |  | ) |

slot

Export to POVRay whithout showing file dialog.

## exportPNG [1/2]

String BALL::VIEW::Scene::exportPNG | ( |  | ) |

slot

Export PNG image and return the filename.

## exportPNG() [2/2]

bool BALL::VIEW::Scene::exportPNG | ( | const String & | filename | ) |

## exportPOVRay

void BALL::VIEW::Scene::exportPOVRay | ( |  | ) |

slot

## exportScene()

virtual bool BALL::VIEW::Scene::exportScene | ( | Renderer & | er | ) | const

virtual

This method exports the content of the Scene to an external Renderer.

## fetchPreferences()

virtual void BALL::VIEW::Scene::fetchPreferences | ( | INIFile & | inifile | ) |

virtual

Fetch the widgets preferences from the INIFile. This method is called automatically by MainControl::show() at the start of the application.

Parameters

  inifile | the INIFile that contains the needed values

See also
  writePreferences

Reimplemented from BALL::VIEW::ModularWidget.

## finalizePreferencesTab()

void BALL::VIEW::Scene::finalizePreferencesTab | ( | Preferences & | preferences | ) |

virtual

Remove the preferences tab. This method can remove a preferences widget (if created in initializePreferencesTab) from the Preferences dialog of the MainControl. This method is called automatically by MainControl::aboutToExit() at the end of the application.

Parameters

  preferences | the Preferences dialog of the MainControl

Reimplemented from BALL::VIEW::ModularWidget.

## getAnimationPoints()

std::list< Camera > & BALL::VIEW::Scene::getAnimationPoints | ( |  | ) |

inline

Definition at line 340 of file scene.h.

## getAnimationSmoothness()

float BALL::VIEW::Scene::getAnimationSmoothness | ( |  | ) |

inline static

Definition at line 348 of file scene.h.

## getBondOrderString_()

String BALL::VIEW::Scene::getBondOrderString_ | ( | Index | order | ) |

## getClickedItems()

void BALL::VIEW::Scene::getClickedItems | ( | const QPoint & | p | ) |

## getContainers()

std::list< AtomContainer * > BALL::VIEW::Scene::getContainers | ( |  | ) |

## getCurrentAtom()

Atom * BALL::VIEW::Scene::getCurrentAtom | ( |  | ) |

inline

Definition at line 282 of file scene.h.

## getCurrentBond()

Bond * BALL::VIEW::Scene::getCurrentBond | ( |  | ) |

inline

Definition at line 300 of file scene.h.

## getDownsamplingFactor()

float BALL::VIEW::Scene::getDownsamplingFactor | ( |  | ) | const

inline

Definition at line 352 of file scene.h.

## getEditElementType

int BALL::VIEW::Scene::getEditElementType | ( |  | ) |

slot

## getGLRenderer()

GLRenderer & BALL::VIEW::Scene::getGLRenderer | ( |  | ) |

inline

Definition at line 382 of file scene.h.

## getInteractionModeManager

InteractionModeManager & BALL::VIEW::Scene::getInteractionModeManager | ( |  | ) |

inline slot

Returns a reference to the Scene's interaction mode manager.

Definition at line 641 of file scene.h.

## getMaterialSettings() [1/2]

MaterialSettings * BALL::VIEW::Scene::getMaterialSettings | ( |  | ) |

inline

Definition at line 329 of file scene.h.

## getMaterialSettings() [2/2]

const MaterialSettings * BALL::VIEW::Scene::getMaterialSettings | ( |  | ) | const

inline

Definition at line 333 of file scene.h.

## getMouseSensitivity()

BALL_DEPRECATED float BALL::VIEW::Scene::getMouseSensitivity | ( |  | ) |

inline static

Deprecated
  Returns zero; use getInteractionModeManager() instead

Definition at line 365 of file scene.h.

## getMouseWheelSensitivity()

BALL_DEPRECATED float BALL::VIEW::Scene::getMouseWheelSensitivity | ( |  | ) |

inline static

Deprecated
  Returns zero; use getInteractionModeManager() instead

Definition at line 371 of file scene.h.

## getScreenPosition_()

TVector2< float > BALL::VIEW::Scene::getScreenPosition_ | ( | Vector3 | vec | ) |

protected

Given a 3-dim. Coordinates (in Viewing Volume) getScreenPosition computes the 2-dim Coordinates on Screen.

## getStage() [1/2]

Stage * BALL::VIEW::Scene::getStage | ( |  | ) |

inline

Definition at line 313 of file scene.h.

## getStage() [2/2]

const Stage * BALL::VIEW::Scene::getStage | ( |  | ) | const

inline

Definition at line 317 of file scene.h.

## getStageSettings() [1/2]

StageSettings * BALL::VIEW::Scene::getStageSettings | ( |  | ) |

inline

Definition at line 321 of file scene.h.

## getStageSettings() [2/2]

const StageSettings * BALL::VIEW::Scene::getStageSettings | ( |  | ) | const

inline

Definition at line 325 of file scene.h.

## getTurnPoint()

const Vector3 & BALL::VIEW::Scene::getTurnPoint | ( |  | ) | const

inline

Definition at line 465 of file scene.h.

## handleCompositeMessage_()

void BALL::VIEW::Scene::handleCompositeMessage_ | ( | CompositeMessage * | cm | ) |

protected

React to CompositeMessages.

## handleControlSelectionMessage_()

void BALL::VIEW::Scene::handleControlSelectionMessage_ | ( | ControlSelectionMessage * | csm | ) |

protected

React to ControlSelectionMessages.

## handleDatasetMessage_()

void BALL::VIEW::Scene::handleDatasetMessage_ | ( | DatasetMessage * | dm | ) |

protected

React to DatasetMessages.

## handleRenderToBufferFinishedEvent_()

virtual void BALL::VIEW::Scene::handleRenderToBufferFinishedEvent_ | ( | RenderToBufferFinishedEvent * | evt | ) |

protected virtual

React to RenderToBufferFinishedEvents

## handleRepresentationMessage_()

void BALL::VIEW::Scene::handleRepresentationMessage_ | ( | RepresentationMessage * | rm | ) |

protected

React to RepresentationMessages.

## handleSceneMessage_()

void BALL::VIEW::Scene::handleSceneMessage_ | ( | SceneMessage * | sm | ) |

protected

React to SceneMessages.

## init()

virtual void BALL::VIEW::Scene::init | ( |  | ) |

protected virtual

Initialize the scene and all predefined render setups.

## initializeMembers_()

void BALL::VIEW::Scene::initializeMembers_ | ( |  | ) |

protected

## initializePreferencesTab()

void BALL::VIEW::Scene::initializePreferencesTab | ( | Preferences & | preferences | ) |

virtual

Initialize a preferences tab for the widget (if needed). This method can be used to create preferences widgets that can be inserted into the Preferences dialog with the method insertTab. This method is called automatically by MainControl::show at the start of the application.

Parameters

  preferences | the Preferences dialog of the MainControl

Reimplemented from BALL::VIEW::ModularWidget.

## initializeWidget()

virtual void BALL::VIEW::Scene::initializeWidget | ( | MainControl & | main_control | ) |

virtual

ModularWidget methods. Initialize the popup menu Display and the menus of this scene:

- the rotate mode (all mouse actions are attached to rotating, translating and zooming the scene)
- the picking mode (all mouse actions are attached to picking objects from the scene)
    This method is called automatically immediately before the main application is started by MainControl::show().
  Parameters

    main_control | the MainControl object to be initialized with this scene

Reimplemented from BALL::VIEW::ModularWidget.

## inMoveMode()

bool BALL::VIEW::Scene::inMoveMode | ( |  | ) | const

## insert_()

void BALL::VIEW::Scene::insert_ | ( | int | x_,
|  | int | y_,
|  | PDBAtom & | atom_ )

protected

Insert a given Atom in the Scene. Its position is specified by the 2-dim Mouseclick coordinates of the Screen, which will be translated into the 3-dim space of Viewing Volume.

## isAnimationRunning()

bool BALL::VIEW::Scene::isAnimationRunning | ( |  | ) | const

## isRecording()

bool BALL::VIEW::Scene::isRecording | ( |  | ) | const

## isUpdateRunning()

bool BALL::VIEW::Scene::isUpdateRunning | ( |  | ) | const

inline

Definition at line 479 of file scene.h.

## isValid()

virtual bool BALL::VIEW::Scene::isValid | ( |  | ) | const

virtual

Internal state and consistency self-validation. A Scene is valid if it has a parent.

Reimplemented from BALL::VIEW::ConnectionObject.

## keyPressEvent()

virtual void BALL::VIEW::Scene::keyPressEvent | ( | QKeyEvent * | e | ) |

virtual

Catch key events.

## lightsUpdated()

void BALL::VIEW::Scene::lightsUpdated | ( | bool | redraw = false | ) |

## map3DToViewport()

Vector2 BALL::VIEW::Scene::map3DToViewport | ( | const Vector3 & | coords | ) |

## mapViewportTo3D() [1/2]

Vector3 BALL::VIEW::Scene::mapViewportTo3D | ( | const Vector2 & | coords | ) |

## mapViewportTo3D() [2/2]

Vector3 BALL::VIEW::Scene::mapViewportTo3D | ( | int | x,
|  | int | y )

## merge()

void BALL::VIEW::Scene::merge | ( | Composite * | a1,
|  | Composite * | a2 )

## motionTrackingEvent()

virtual void BALL::VIEW::Scene::motionTrackingEvent | ( | MotionTrackingEvent * | evt | ) |

protected virtual

Function that interpretes the motion tracker events sent to customEvent()

## mouseDoubleClickEvent()

virtual void BALL::VIEW::Scene::mouseDoubleClickEvent | ( | QMouseEvent * | e | ) |

protected virtual

## mouseMoveEvent()

virtual void BALL::VIEW::Scene::mouseMoveEvent | ( | QMouseEvent * | qmouse_event | ) |

protected virtual

Catch mouse move events, store the actual mouse position in this scene widget and sent events accordingly.

Parameters

  e | the QT-mouse event (See QT-library for mouse events)

## mousePressEvent()

virtual void BALL::VIEW::Scene::mousePressEvent | ( | QMouseEvent * | qmouse_event | ) |

protected virtual

Catch mouse press events, store the actual mouse position in this scene widget and sent events accordingly.

Parameters

  e | the QT-mouse event (See QT-library for mouse events)

## mouseReleaseEvent()

virtual void BALL::VIEW::Scene::mouseReleaseEvent | ( | QMouseEvent * | qmouse_event | ) |

protected virtual

Catch mouse release events, store the actual mouse position in this scene widget and sent events accordingly.

Parameters

  e | the QT-mouse event (See QT-library for mouse events)

## move()

void BALL::VIEW::Scene::move | ( | Vector3 | v | ) |

Move the view. \ v.x = right \ v.y = up \ v.z = view direction

## moveComposites()

void BALL::VIEW::Scene::moveComposites | ( | const std::list< Composite * > & | composites,
|  | Vector3 | v )

Move some Composites. \ v.x = right \ v.y = up \ v.z = view direction

## newEditOperation

void BALL::VIEW::Scene::newEditOperation | ( | EditOperation & | eo | ) |

signal

## notify()

void BALL::VIEW::Scene::notify | ( | Message * | msg | ) |

inline

Definition at line 284 of file scene.h.

## onNotify()

virtual void BALL::VIEW::Scene::onNotify | ( | Message * | message | ) |

virtual

Handles messages sent by other registered ConnectionObject objects. Filters for SceneMessage and sets the Camera appropriate or updates the visualization.

Parameters

  message | the pointer to the message that should be processed

See also
  ConnectionObject
  Message

Reimplemented from BALL::VIEW::ConnectionObject.

## optimizeStructure

void BALL::VIEW::Scene::optimizeStructure | ( |  | ) |

slot

## paintEvent()

virtual void BALL::VIEW::Scene::paintEvent | ( | QPaintEvent * | e | ) |

virtual

## paintGL()

virtual void BALL::VIEW::Scene::paintGL | ( |  | ) |

protected virtual

Render the visualization. Overriden qt method for rendering the visualization of this scene. This method will be called automatically every time an update is necessary. See QT-library for information concerning qglwidgets and paintGL methods and events.

See also
  MainControl

## pickObjects() [1/2]

void BALL::VIEW::Scene::pickObjects | ( | const QPoint & | pos,
|  | list< GeometricObject * > & | objects )

## pickObjects() [2/2]

void BALL::VIEW::Scene::pickObjects | ( | const QPoint & | pos1,
|  | const QPoint & | pos2,
|  | list< GeometricObject * > & | objects )

## pickParent_()

void BALL::VIEW::Scene::pickParent_ | ( | QPoint | p | ) |

protected

## prepareGridTextures()

Position BALL::VIEW::Scene::prepareGridTextures | ( | const RegularData3D & | grid,
|  | const ColorMap & | map )

## printScene

void BALL::VIEW::Scene::printScene | ( |  | ) |

slot

## projectionModeChanged()

virtual void BALL::VIEW::Scene::projectionModeChanged | ( |  | ) |

virtual

## readLights_()

void BALL::VIEW::Scene::readLights_ | ( | const INIFile & | inifile | ) |

protected

## registerRenderers_()

void BALL::VIEW::Scene::registerRenderers_ | ( |  | ) |

protected

## renderGrid_()

void BALL::VIEW::Scene::renderGrid_ | ( |  | ) |

protected

## renderText_()

void BALL::VIEW::Scene::renderText_ | ( | QPointF const & | point,
|  | QString const & | text,
|  | QPaintDevice * | current_dev )

protected

Render a text at the given position. Currently, this always uses a 16pt Arial bold font. TODO: this should be configurable in the GUI.

## resetCamera_

virtual void BALL::VIEW::Scene::resetCamera_ | ( |  | ) |

protected virtual slot

Reset the camera to standard values.

## resetRepresentationsForRenderer_

virtual void BALL::VIEW::Scene::resetRepresentationsForRenderer_ | ( | RenderSetup & | rs | ) |

protected virtual slot

Rebuffer all representations for the current renderer_. Note: this function does not yet clear the old state of the renderer.

## resetTracking()

void BALL::VIEW::Scene::resetTracking | ( |  | ) |

inline

Definition at line 481 of file scene.h.

## resizeEvent()

virtual void BALL::VIEW::Scene::resizeEvent | ( | QResizeEvent * | event | ) |

protected virtual

Resize the widget. Overridden qt method for resizing this scene. This method will be called automatically every time a rezize event is handled.

Parameters

  width | the new width of this scene
  height | the new height of this scene

## restoreViewPoint

void BALL::VIEW::Scene::restoreViewPoint | ( |  | ) |

slot

## rotate()

void BALL::VIEW::Scene::rotate | ( | float | degree_right,
|  | float | degree_up )

## rotateClockwise()

void BALL::VIEW::Scene::rotateClockwise | ( | float | degree | ) |

## rotateComposites()

void BALL::VIEW::Scene::rotateComposites | ( | const std::list< Composite * > & | composites,
|  | float | degree_right,
|  | float | degree_up,
|  | float | degree_clockwise = 0 )

Rotate some Composites. \ v.x = right \ v.y = up \ v.z = view direction

## rotateSystemClockwise_()

void BALL::VIEW::Scene::rotateSystemClockwise_ | ( |  | ) |

protected

## saturateWithHydrogens

void BALL::VIEW::Scene::saturateWithHydrogens | ( |  | ) |

slot

## selectionPressed_()

void BALL::VIEW::Scene::selectionPressed_ | ( |  | ) |

protected

## selectionPressedMoved_()

void BALL::VIEW::Scene::selectionPressedMoved_ | ( |  | ) |

protected

## selectObjects_()

void BALL::VIEW::Scene::selectObjects_ | ( |  | ) |

protected

## setAnimationSmoothness()

void BALL::VIEW::Scene::setAnimationSmoothness | ( | float | value | ) |

inline static

Definition at line 344 of file scene.h.

## setCamera()

void BALL::VIEW::Scene::setCamera | ( | const Camera & | camera | ) |

## setCurrentAtom()

void BALL::VIEW::Scene::setCurrentAtom | ( | Atom * | atom | ) |

inline

Definition at line 283 of file scene.h.

## setCurrentBond()

void BALL::VIEW::Scene::setCurrentBond | ( | Bond * | b | ) |

inline

Definition at line 301 of file scene.h.

## setCursor()

void BALL::VIEW::Scene::setCursor | ( | String | c | ) |

## setDefaultLighting()

void BALL::VIEW::Scene::setDefaultLighting | ( | bool | update_GL = true | ) |

## setDownsamplingFactor()

void BALL::VIEW::Scene::setDownsamplingFactor | ( | float | ds_factor | ) |

## setEditElementType

void BALL::VIEW::Scene::setEditElementType | ( | int | element_number | ) |

slot

## setElementCursor()

void BALL::VIEW::Scene::setElementCursor | ( | int | number | ) |

## setFormalCharge_()

void BALL::VIEW::Scene::setFormalCharge_ | ( |  | ) |

## setFPSEnabled()

void BALL::VIEW::Scene::setFPSEnabled | ( | bool | state | ) |

inline

Definition at line 471 of file scene.h.

## setFullScreen()

void BALL::VIEW::Scene::setFullScreen | ( | bool | state | ) |

## setGLRenderer()

void BALL::VIEW::Scene::setGLRenderer | ( | GLRenderer & | renderer | ) |

Set a new GLRenderer. This method is intended for users, that what to overload the behaviour of the GLRenderer.

## setInfo()

void BALL::VIEW::Scene::setInfo | ( | const QString & | info_string | ) |

## setMouseSensitivity()

BALL_DEPRECATED void BALL::VIEW::Scene::setMouseSensitivity | ( | float |  | ) |

inline static

Deprecated
  Does nothing; use getInteractionModeManager() instead

Definition at line 362 of file scene.h.

## setMouseWheelSensitivity()

BALL_DEPRECATED void BALL::VIEW::Scene::setMouseWheelSensitivity | ( | float |  | ) |

inline static

Deprecated
  Does nothing; use getInteractionModeManager() instead

Definition at line 368 of file scene.h.

## setOffScreenRendering()

void BALL::VIEW::Scene::setOffScreenRendering | ( | bool | enabled,
|  | Size | factor )

## setPOVNumber()

void BALL::VIEW::Scene::setPOVNumber | ( | Position | pos | ) |

inline static

Definition at line 425 of file scene.h.

## setPreview

void BALL::VIEW::Scene::setPreview | ( | bool | state | ) |

inline slot

Enable or disable model previews e.g. while rotating.

Definition at line 550 of file scene.h.

## setRubberBandGeometry()

void BALL::VIEW::Scene::setRubberBandGeometry | ( | const QRect & | rect | ) |

## setRubberBandVisible()

void BALL::VIEW::Scene::setRubberBandVisible | ( | bool | show | ) |

## setScreenShotNumber()

void BALL::VIEW::Scene::setScreenShotNumber | ( | Position | pos | ) |

inline static

Definition at line 422 of file scene.h.

## setShowLightSources()

void BALL::VIEW::Scene::setShowLightSources | ( | bool | state | ) |

inline static

Definition at line 374 of file scene.h.

## setTurnPoint()

void BALL::VIEW::Scene::setTurnPoint | ( | const Vector3 & | v | ) |

inline

Definition at line 462 of file scene.h.

## setupEnvironmentMap()

void BALL::VIEW::Scene::setupEnvironmentMap | ( | const QImage & | image | ) |

Try to setup an environment map for all renderers that support it.

## setupViewVolume

void BALL::VIEW::Scene::setupViewVolume | ( |  | ) |

slot

## setViewPoint_

virtual void BALL::VIEW::Scene::setViewPoint_ | ( |  | ) |

protected virtual slot

Set the viewpoint.

## setVRMLNumber()

void BALL::VIEW::Scene::setVRMLNumber | ( | Position | pos | ) |

inline static

Definition at line 428 of file scene.h.

## setWidgetVisible()

virtual void BALL::VIEW::Scene::setWidgetVisible | ( | bool | state | ) |

virtual

## showContextMenu()

void BALL::VIEW::Scene::showContextMenu | ( | QPoint | pos | ) |

## showExportPNGDialog

void BALL::VIEW::Scene::showExportPNGDialog | ( |  | ) |

slot

show an dialog to save an PNG file to

## showExportVRMLDialog

void BALL::VIEW::Scene::showExportVRMLDialog | ( |  | ) |

slot

opens the VIEW/DIALOGS/GeometryExportDialog for vrml and stl export

## showInfos

void BALL::VIEW::Scene::showInfos | ( |  | ) |

slot

Popup informations for object under mouse cursor.

## showLightSourcesEnabled()

bool BALL::VIEW::Scene::showLightSourcesEnabled | ( |  | ) |

inline static

Definition at line 378 of file scene.h.

## showText()

void BALL::VIEW::Scene::showText | ( | const String & | text,
|  | Size | font_size = 20 )

Show text in the lower right corner. To clear the text, call this method again with an empty string.

## showViewPoint_

virtual void BALL::VIEW::Scene::showViewPoint_ | ( |  | ) |

protected virtual slot

Show the viewpoint and the look at point in the statusline of the mainwidget.

## startAnimation

void BALL::VIEW::Scene::startAnimation | ( |  | ) |

slot

## startContinuousLoop

void BALL::VIEW::Scene::startContinuousLoop | ( |  | ) |

slot

## stereoBufferSupportTest()

bool BALL::VIEW::Scene::stereoBufferSupportTest | ( |  | ) |

static

## stopAnimation

void BALL::VIEW::Scene::stopAnimation | ( |  | ) |

slot

## stopContinuousLoop

void BALL::VIEW::Scene::stopContinuousLoop | ( |  | ) |

slot

## storeViewPoint

void BALL::VIEW::Scene::storeViewPoint | ( |  | ) |

slot

## switchRenderer

void BALL::VIEW::Scene::switchRenderer | ( | RenderSetup::RendererType | new_type | ) |

slot

## switchShowGrid

void BALL::VIEW::Scene::switchShowGrid | ( |  | ) |

slot

## switchShowWidget

virtual void BALL::VIEW::Scene::switchShowWidget | ( |  | ) |

virtual slot

Show or hide widget (Called by menu entry in "WINDOWS") If the ModularWidget is not also a QWidget, this method does nothing

## switchToLastMode

void BALL::VIEW::Scene::switchToLastMode | ( |  | ) |

slot

## toggleContinuousLoop

void BALL::VIEW::Scene::toggleContinuousLoop | ( |  | ) |

slot

## transformationEvent6D()

virtual void BALL::VIEW::Scene::transformationEvent6D | ( | TransformationEvent6D * | evt | ) |

protected virtual

Function that interpretes the transformation events sent to customEvent()

## updateAllMaterials()

void BALL::VIEW::Scene::updateAllMaterials | ( |  | ) |

## updateGL()

void BALL::VIEW::Scene::updateGL | ( |  | ) |

## updateMaterialForRepresentation()

void BALL::VIEW::Scene::updateMaterialForRepresentation | ( | Representation * | rep,
|  | const Stage::Material & | new_material )

## usePreview

bool BALL::VIEW::Scene::usePreview | ( |  | ) | const

inline slot

Returns the state of the preview mode.

Definition at line 553 of file scene.h.

## useVertexBuffers

bool BALL::VIEW::Scene::useVertexBuffers | ( |  | ) | const

inline slot

Definition at line 555 of file scene.h.

## wheelEvent()

virtual void BALL::VIEW::Scene::wheelEvent | ( | QWheelEvent * | qmouse_event | ) |

protected virtual

Catch mouse wheel events and zoom the scene accordingly.

Parameters

  e | the QT-mouse event (See QT-library for mouse events)

## writeLights_()

void BALL::VIEW::Scene::writeLights_ | ( | INIFile & | inifile | ) | const

protected

## writePreferences()

virtual void BALL::VIEW::Scene::writePreferences | ( | INIFile & | inifile | ) |

virtual

Writes the widgets preferences to the INIFile. This method is called automatically by MainControl::aboutToExit at the end of the application.

Parameters

  inifile | the INIFile to contain the values

See also
  fetchPreferences

Reimplemented from BALL::VIEW::ModularWidget.

## zoomSystem_()

void BALL::VIEW::Scene::zoomSystem_ | ( |  | ) |

protected

## Friends And Related Symbol Documentation

## AnimationThread

friend class AnimationThread

friend

Definition at line 142 of file scene.h.

## RenderSetup

friend class RenderSetup

friend

Definition at line 143 of file scene.h.

## Member Data Documentation

## active_stereo_action_

QAction * BALL::VIEW::Scene::active_stereo_action_

protected

Definition at line 850 of file scene.h.

## add_hydrogens_action_

QAction* BALL::VIEW::Scene::add_hydrogens_action_

protected

Definition at line 734 of file scene.h.

## animation_export_PNG_action_

QAction * BALL::VIEW::Scene::animation_export_PNG_action_

protected

Definition at line 852 of file scene.h.

## animation_export_POV_action_

QAction* BALL::VIEW::Scene::animation_export_POV_action_

protected

Definition at line 852 of file scene.h.

## animation_export_VRML_action_

QAction * BALL::VIEW::Scene::animation_export_VRML_action_

protected

Definition at line 852 of file scene.h.

## animation_points_

std::list<Camera> BALL::VIEW::Scene::animation_points_

protected

Definition at line 896 of file scene.h.

## animation_repeat_action_

QAction * BALL::VIEW::Scene::animation_repeat_action_

protected

Definition at line 852 of file scene.h.

## animation_smoothness_

float BALL::VIEW::Scene::animation_smoothness_

static protected

Definition at line 882 of file scene.h.

## animation_thread_

AnimationThread* BALL::VIEW::Scene::animation_thread_

protected

Definition at line 897 of file scene.h.

## atomic_number_

int BALL::VIEW::Scene::atomic_number_

protected

Definition at line 743 of file scene.h.

## bondorders_action_

QAction* BALL::VIEW::Scene::bondorders_action_

protected

Definition at line 735 of file scene.h.

## cancel_animation_action_

QAction * BALL::VIEW::Scene::cancel_animation_action_

protected

Definition at line 851 of file scene.h.

## clear_animation_action_

QAction * BALL::VIEW::Scene::clear_animation_action_

protected

Definition at line 851 of file scene.h.

## create_coordinate_system_

QMenu* BALL::VIEW::Scene::create_coordinate_system_

protected

Definition at line 858 of file scene.h.

## current_atom_

Atom* BALL::VIEW::Scene::current_atom_

protected

Definition at line 737 of file scene.h.

## current_bond_

Bond* BALL::VIEW::Scene::current_bond_

protected

Definition at line 738 of file scene.h.

## default_font_

QFont BALL::VIEW::Scene::default_font_

protected

Definition at line 926 of file scene.h.

## downsampling_factor_

float BALL::VIEW::Scene::downsampling_factor_

static protected

Definition at line 883 of file scene.h.

## dual_stereo_action_

QAction * BALL::VIEW::Scene::dual_stereo_action_

protected

Definition at line 850 of file scene.h.

## dual_stereo_different_display_action_

QAction * BALL::VIEW::Scene::dual_stereo_different_display_action_

protected

Definition at line 850 of file scene.h.

## edit_settings_

EditSettings* BALL::VIEW::Scene::edit_settings_

protected

Definition at line 747 of file scene.h.

## enter_stereo_action_

QAction * BALL::VIEW::Scene::enter_stereo_action_

protected

Definition at line 850 of file scene.h.

## font_size_

Size BALL::VIEW::Scene::font_size_

protected

Definition at line 912 of file scene.h.

## fps_

list<float> BALL::VIEW::Scene::fps_

protected

Definition at line 908 of file scene.h.

## gl_renderer_

GLRenderer* BALL::VIEW::Scene::gl_renderer_

protected

Definition at line 874 of file scene.h.

## has_overlay_

bool BALL::VIEW::Scene::has_overlay_

protected

Definition at line 929 of file scene.h.

## info_point_

QPoint BALL::VIEW::Scene::info_point_

protected

Definition at line 906 of file scene.h.

## info_string_

QString BALL::VIEW::Scene::info_string_

protected

Definition at line 917 of file scene.h.

## last_state_

QByteArray BALL::VIEW::Scene::last_state_

protected

Definition at line 907 of file scene.h.

## light_settings_

LightSettings* BALL::VIEW::Scene::light_settings_

protected

Definition at line 885 of file scene.h.

## main_display_

GLRenderWindow* BALL::VIEW::Scene::main_display_

protected

Definition at line 919 of file scene.h.

## main_renderer_

Position BALL::VIEW::Scene::main_renderer_

protected

The index of the renderer responsible for the main display.

Definition at line 921 of file scene.h.

## material_settings_

MaterialSettings* BALL::VIEW::Scene::material_settings_

protected

Definition at line 887 of file scene.h.

## mode_manager_

InteractionModeManager BALL::VIEW::Scene::mode_manager_

protected

Definition at line 930 of file scene.h.

## new_molecule_action_

QAction* BALL::VIEW::Scene::new_molecule_action_

protected

Definition at line 733 of file scene.h.

## no_stereo_action_

QAction* BALL::VIEW::Scene::no_stereo_action_

protected

Definition at line 850 of file scene.h.

## offscreen_factor_

Size BALL::VIEW::Scene::offscreen_factor_

protected

Definition at line 911 of file scene.h.

## offscreen_rendering_

bool BALL::VIEW::Scene::offscreen_rendering_

static protected

Definition at line 910 of file scene.h.

## old_trackorigin_

Vector3 BALL::VIEW::Scene::old_trackorigin_

protected

Definition at line 861 of file scene.h.

## old_trackrotation_

Quaternion BALL::VIEW::Scene::old_trackrotation_

protected

Definition at line 863 of file scene.h.

## only_highlighted_

bool BALL::VIEW::Scene::only_highlighted_

static protected

Definition at line 741 of file scene.h.

## optimize_action_

QAction * BALL::VIEW::Scene::optimize_action_

protected

Definition at line 733 of file scene.h.

## overlay_

QPicture BALL::VIEW::Scene::overlay_

protected

Definition at line 928 of file scene.h.

## pov_nr_

Position BALL::VIEW::Scene::pov_nr_

static protected

Definition at line 892 of file scene.h.

## rb_

QRubberBand* BALL::VIEW::Scene::rb_

protected

Definition at line 867 of file scene.h.

## record_animation_action_

QAction* BALL::VIEW::Scene::record_animation_action_

protected

Definition at line 851 of file scene.h.

## renderers_

std::vector<boost::shared_ptr<RenderSetup> > BALL::VIEW::Scene::renderers_

protected

Definition at line 873 of file scene.h.

## screenshot_nr_

Position BALL::VIEW::Scene::screenshot_nr_

static protected

Definition at line 890 of file scene.h.

## show_fps_

bool BALL::VIEW::Scene::show_fps_

protected

Definition at line 909 of file scene.h.

## show_light_sources_

bool BALL::VIEW::Scene::show_light_sources_

static protected

Definition at line 881 of file scene.h.

## stage_

Stage* BALL::VIEW::Scene::stage_

protected

Definition at line 869 of file scene.h.

## stage_settings_

StageSettings* BALL::VIEW::Scene::stage_settings_

protected

Definition at line 886 of file scene.h.

## start_animation_action_

QAction * BALL::VIEW::Scene::start_animation_action_

protected

Definition at line 851 of file scene.h.

## stereo_camera_

Camera BALL::VIEW::Scene::stereo_camera_

protected

Definition at line 870 of file scene.h.

## stereo_left_eye_

Index BALL::VIEW::Scene::stereo_left_eye_

protected

Definition at line 923 of file scene.h.

## stereo_right_eye_

Index BALL::VIEW::Scene::stereo_right_eye_

protected

Definition at line 924 of file scene.h.

## stop_animation_

bool BALL::VIEW::Scene::stop_animation_

protected

Definition at line 898 of file scene.h.

## stored_camera_

Camera BALL::VIEW::Scene::stored_camera_

protected

Definition at line 871 of file scene.h.

## switch_grid_

QAction* BALL::VIEW::Scene::switch_grid_

protected

Definition at line 857 of file scene.h.

## system_origin_

Vector3 BALL::VIEW::Scene::system_origin_

protected

Definition at line 860 of file scene.h.

## time_

PreciseTime BALL::VIEW::Scene::time_

protected

Definition at line 905 of file scene.h.

## toolbar_actions_edit_controls_

QList<QAction*> BALL::VIEW::Scene::toolbar_actions_edit_controls_

protected

Definition at line 748 of file scene.h.

## toolbar_actions_view_controls_

QList<QAction*> BALL::VIEW::Scene::toolbar_actions_view_controls_

protected

Definition at line 915 of file scene.h.

## toolbar_edit_controls_

QToolBar* BALL::VIEW::Scene::toolbar_edit_controls_

protected

Definition at line 914 of file scene.h.

## toolbar_view_controls_

QToolBar* BALL::VIEW::Scene::toolbar_view_controls_

protected

Definition at line 913 of file scene.h.

## tracking_initialized_

bool BALL::VIEW::Scene::tracking_initialized_

protected

Definition at line 862 of file scene.h.

## undo_

vector<EditOperation> BALL::VIEW::Scene::undo_

protected

Definition at line 746 of file scene.h.

## update_running_

bool BALL::VIEW::Scene::update_running_

protected

Definition at line 865 of file scene.h.

## use_preview_

bool BALL::VIEW::Scene::use_preview_

protected

Definition at line 903 of file scene.h.

## vrml_nr_

Position BALL::VIEW::Scene::vrml_nr_

static protected

Definition at line 894 of file scene.h.

## want_to_use_vertex_buffer_

bool BALL::VIEW::Scene::want_to_use_vertex_buffer_

protected

Definition at line 902 of file scene.h.